<?php

declare(strict_types=1);

namespace Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects;

use InvalidArgumentException;
use Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum;

/**
 * Class PocetKontrolPodlaDruhu
 *
 * @package Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects
 */
final class PocetKontrolPodlaDruhu implements PocetKontrol
{
    /**
     * @var \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    private DruhEmisnejKontrolyEnum $druh;

    /**
     * @var int
     */
    private int $pocet;

    /**
     * PocetKontrolPodlaDruhu constructor.
     *
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum $druh
     * @param int                                                                         $pocet
     */
    public function __construct(DruhEmisnejKontrolyEnum $druh, int $pocet)
    {
        $this->druh = $druh;
        $this->pocet = $pocet;
    }

    /**
     * @return \Seka\Portal\Modul\Statistiky\Entities\Zaznam\Enums\DruhEmisnejKontrolyEnum
     */
    public function druh(): DruhEmisnejKontrolyEnum
    {
        return $this->druh;
    }

    /**
     * @return int
     */
    public function pocet(): int
    {
        return $this->pocet;
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu $pocetKontrolPodlaDruhu
     *
     * @return bool
     */
    public function equalsDruh(self $pocetKontrolPodlaDruhu): bool
    {
        return $this->druh->equals($pocetKontrolPodlaDruhu->druh());
    }

    /**
     * @param \Seka\Portal\Modul\Statistiky\Entities\Zaznam\ValueObjects\PocetKontrolPodlaDruhu $pocetKontrolPodlaDruhu
     *
     * @return $this
     */
    public function navysitPocet(self $pocetKontrolPodlaDruhu): self
    {
        if (false === $pocetKontrolPodlaDruhu->druh->equals($this->druh)) {
            throw new InvalidArgumentException('Navysenie poctu kontrol podla ineho druhu kontroly nie je mozne.');
        }

        return new self(
            $this->druh,
            $this->pocet + $pocetKontrolPodlaDruhu->pocet()
        );
    }

    /**
     * @return array
     */
    public function toArray(): array
    {
        return [
            'druh' => $this->druh->value,
            'pocet' => $this->pocet,
        ];
    }

    /**
     * @return string
     */
    public function jsonSerialize(): string
    {
        return json_encode($this->toArray());
    }
}
